// *****************************************************************
// ****		          UART0 and other debug routines            ****
// ****                     www.tolaemon.com                    ****
// ****                       Source code                       ****
// ****                       16-10-2008                        ****
// ****                     Jordi Bartolome                     ****
// ****                                                         ****
// **** IMPORTANT:                                              ****
// **** Using parts of this code means accepting all conditions ****
// **** exposed on the web: www.tolaemon.com/hplayer            ****
// *****************************************************************
#ifndef _UART0_
#define _UART0_

#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include "ayfwre.h"
#include "lcdg.h"
#include "sdc.h"
#include "fat32.h"
#include "ay3891x.h"
#include "iocompat.h"

#define MAX_UART_BUFFER 64


typedef struct {
	uint8_t recv_write_index; // points to the first writeable postion in the reception buffer
	uint8_t recv_read_index; // points to the first byte to read in the reception buffer
	uint8_t recv_buffer[MAX_UART_BUFFER];// is the UART reception buffer
	uint8_t trans_write_index; // points to the first writeable postion in the transmision buffer
	uint8_t trans_read_index; // points to the first byte to read in the transmision buffer
	uint8_t trans_buffer[MAX_UART_BUFFER];// is the UART transmision buffer
}t_uart_buffer;


void UART_Init();
uint8_t UART0_TransmitByte( uint8_t data );
uint8_t UART0_PushByteIntoTransmissionBuffer( uint8_t data );
uint8_t UART0_PollBufferTransmission( );
uint8_t UART0_ReadRecivedByte(unsigned char * data );
void UART0_ParseRecivedBytes();
void UART0_Reset( );
void UART0_Motor();
uint8_t UART0_TransmisionBufferEmpty( );
void UART0_ForceTransmitByte( uint8_t data );
uint8_t UART0_PrintString( uint8_t * string);
uint8_t UART0_PrintUint( uint32_t value );
void UART0_ForceBufferTransmission( );
uint8_t UART0_PrintByte( uint8_t byte_to_print);

#endif
